      PROGRAM VGADEMO
C
C This program is designed to show the effects that can be achieved using
C the VGA mode 19 (320x200 in 256 colours from a palette of 262,144). It
C relies on filling the screen with a pattern using as many colours as
C possible, and then either changing the colours one by one, or by rotaing
C the colours. These use the two F77-PC routines, VGAPalette and VGAFlash.
C As may be observed, on some VGA adaptors, the display quality can be very
C poor when repeatedly using VGAFlash. This may be made better or worse
C by using AwaitRetrace.
C
C Date: 24 February 1989
C
      INCLUDE 'F77PC'
      INTEGER Stepping
      INTEGER*4 VRed,VGreen,VBlue
      INTEGER*4 VRedInc,VBlueInc,VGreenInc,Next
      INTEGER*4 Speed,i,j,R,Register
      INTEGER*1 MYARRAY2(0:2,0:256)
      INTEGER*1 MYARRAY(0:2,0:256)
      REAL a,k,ksquared,jsquared,isquared
      PARAMETER (k=0.27)
C
      VRed=0
      VBlue=0
      VGreen=0
      VRedInc=1
      VBlueInc=1
      VGreenInc=1
      Register=1
      Next=0
      ksquared=k*k
      CALL INITSCREEN
      IF (Adaptor() .NE. 4) THEN
	  WRITE (*,110)
	  GOTO 100
      ENDIF
      WRITE (*,120)
      READ *,Speed
      CALL SETSCREENMODE (19)
      DO 30 I=0,159
      DO 30 J=-99,99
	  jsquared=j
	  jsquared=j*j
	  isquared=i
	  isquared=i*i
	  R=2+INT(16*SQRT((SQRT(((1-ksquared)*(isquared+jsquared))+
     (ksquared*jsquared))-k*j)/(1-ksquared))
	  CALL Plot(160-i,100+j,R)
	  CALL Plot(160+i,100+j,R)
30    CONTINUE
      DO 70 Register=1,255
	  CALL VGAPalette(Register,Register/4,Register/8,Register/7)
	  MyArray(0,REGISTER)=Register/4
	  MyArray(1,REGISTER)=Register/8
	  MyArray(2,REGISTER)=Register/7
70    CONTINUE
60    MyArray(0,REGISTER)=VRed
      MyArray(1,REGISTER)=VGreen
      MyArray(2,REGISTER)=VBlue
      Register=Register-1
      IF (Register.EQ.0) THEN
	  Register=254
      ENDIF
      IF (Speed .EQ. 0) THEN
	  CALL VGAPalette(Register,VRed,VGreen,VBlue)
      ELSE
	  Next=Next+1
	  IF (Next.EQ.Speed) THEN
	     Next=0
	     CALL AwaitRetrace
	     CALL VGAFlash(MyArray(0,Register),1,255-register)
	     CALL AwaitRetrace
	     i=256-Register
	     CALL VGAFlash(MyArray(0,1),i,255)
	  ENDIF
      ENDIF
      CALL Cycle(VRed,VRedInc)
      CALL Cycle(VBlue,VBlueInc)
      CALL Cycle(VGreen,VGreenInc)
      IF (.NOT. KEYPRESSED() ) GOTO 60
      CALL INITSCREEN
100   CONTINUE
110   FORMAT(' This program will only run on a Video Graphics Adaptor.')
120   FORMAT(' Enter Speed ')
      END
C
      SUBROUTINE Cycle(Col,ColInc)
      INTEGER*4 Col,ColInc
      REAL A
      Col=Col+ColInc
      IF ((Col .LT. 0) .OR. (Col .GT. 63)) THEN
	  Col=Col-2*ColInc
	  ColInc=-ColInc
      ELSEIF (RANDOM(0) .LE. 0.04) THEN
	 a=RANDOM(0)
	 IF (ColInc .EQ. 0) THEN
	      IF (a .LT. 0.5) THEN
		  ColInc=-1
	      ELSE
		  ColInc=1
	      ENDIF
	  ELSE IF (a .LT. 0.8) THEN
		  ColInc=-ColInc
	      ELSE
		  ColInc=0
	  ENDIF
      ENDIF
      RETURN

      END

